{$M $1024,0,0 }
uses
  PCI, Dos;

const
  Digits: array [0..15] of char='0123456789abcdef';

function UpCaseStr(S:string):string;
var
  i:byte;
begin
  for i:=1 to Length(S) do UpCaseStr[i]:=UpCase(S[i]);
  UpCaseStr[0]:=S[0];
end;

function HexW(W : Word) : string;
begin
  HexW[0] := #4;
  HexW[1] := Digits[hi(W) shr 4];
  HexW[2] := Digits[hi(W) and $F];
  HexW[3] := Digits[lo(W) shr 4];
  HexW[4] := Digits[lo(W) and $F];
end;

var
  BusNumber, DevFnNumber, IRQ, i:byte;
  Port:word;
  ParamString, UParamString, PortStr, IRQStr:string;

begin
  if ParamCount=0 then
    Writeln(#13#10'Runfoss written by WoZZa, 2001.'#13#10+
            'Syntax: runfoss <program> <parameters>'#13#10+
            '<parameters> may contains macros @PORT@ and @IRQ@'#13#10);

  {  $70002 - UART 16550A, ⠪ ।⠢  Hard-PCI- }
  if PCIFindDevice($70002, 0, BusNumber, DevFnNumber)<>PCISuccesful then
  begin
    Writeln('PCI Modem not found.');
    Halt;
  end;
  Port:=PCIReadWord(BusNumber, DevFnNumber, $10)-1;
  {                                            ^^^
    祬-  䨣樮 ࠭⢥  
    㢥祭  1. ⠭ ⮤ 몠.}
  IRQ:=PCIReadByte(BusNumber, DevFnNumber, $3c);
  PortStr:=HexW(Port);
  Str(IRQ, IRQStr);
  Writeln('PCI Modem found at port '+PortStr+'h, IRQ '+IRQStr);

  if ParamCount=0 then Halt;

  ParamString:='';
  for i:=2 to ParamCount do ParamString:=ParamString+ParamStr(i)+' ';
  UParamString:=UpCaseStr(ParamString);

  while true do
  begin
    i:=Pos('@PORT@', UParamString);
    if i=0 then Break;
    Delete(ParamString, i, 6);
    Insert(PortStr, ParamString, i);
    Delete(UParamString, i, 6);
    Insert(PortStr, UParamString, i);
  end;
  while true do
  begin
    i:=Pos('@IRQ@', UParamString);
    if i=0 then Break;
    Delete(ParamString, i, 5);
    Insert(IRQStr, ParamString, i);
    Delete(UParamString, i, 5);
    Insert(IRQStr, UParamString, i);
  end;
  SwapVectors;
  Exec(ParamStr(1), ParamString);
end.